/* Adott az n nem nulla természetes szám (0 < n ≤ 109). Döntsük el, hogy kettőhatvány-e! 
Ha az adott szám nem kettőhatvány, bontsuk kettőhatványok összegére!
Az alábbi megoldások a kettőhatvány eldöntésére hatékonyságuk növekvő sorrendjében következnek
*/

#include <iostream>

using namespace std;

int const maxDim = 100;

bool kettoHatvany_1(unsigned n){
// addig osztjuk a számot 2-vel, amíg 1-hez nem jutunk 
// ha az osztás mindig maradék nélküli volt, => n kettőhatvány

	while((n > 1) && ((n % 2) == 0))
		n /= 2;
	return n == 1;
}

bool kettoHatvany_2(unsigned n){
// generáljuk a kettőhatványokat, amíg ezek kisebbek, mint n 
// ha az utolsó kettőhatvány egyenlő n-nel, => n kettőhatvány

unsigned m = 1;

	while(m < n) 
		m *= 2;
	return m == n;
}

bool kettoHatvany_3(unsigned n){
// megszámoljuk az n 1-es bitjeit 1
// ha egyetlen 1-est találunk, => n kettőhatvány

unsigned nr = 0;			// nr = 1-es bitek darabszáma
	while(n > 0) {			// a szám még nem fogyott el
		if(n & 1)			// ha az utolsó bit értéke 1 
			nr++;			// növeljük a számláló értékét
		n >>= 1;			// n = n >> 1, vagyis eltoljuk jobbra a szám bitjeit Pascal: shr, n = n / 2;
	}
	return nr == 1;			// ha 1 db bitet találtunk csak, akkor a szám kettõhatvány
}

bool kettoHatvany_4(unsigned n){
	
	return ((n & (n - 1)) == 0);
}

bool kettoHatvany_22(unsigned n, unsigned & m){
// generáljuk a kettőhatványokat, amíg ezek kisebbek, mint n 
// ha az utolsó kettőhatvány egyenlő n-nel, => n kettőhatvány

 	m = 1;

	while(m < n) 
		m *= 2;
	return m == n;
}
void felbontas(unsigned n, unsigned m, int & k, unsigned tagok[]){

	k = 0;
	if(!kettoHatvany_22(n, m)){		
		while(n > 0){
			while(m > n)
				m /= 2;
			k++;		
			tagok[k] = m;
			n -= m;
		}
	}
}

void kiIras(unsigned n, int k, unsigned tagok[]){

	cout << n << " = ";  
	for(int i = 1; i <= k - 1; i++)
		cout << tagok[i] << " + ";
	cout << tagok[k] << endl;
}

int main(){	
	unsigned n, m;

	int k = 0;
	unsigned tagok[maxDim];
	
	cout << "n = ";	cin >> n;

	cout << "1. Modszer: ";
	if(kettoHatvany_1(n))
		cout << n << " kettoHatvany!" << endl;	
	else
		cout << n << " NEM kettoHatvany!" << endl;	
		
	cout << "2. Modszer: ";
	if(kettoHatvany_2(n))
		cout << n << " kettoHatvany!" << endl;	
	else{
		cout << n << " NEM kettoHatvany!" << endl;	
		m = 0;
		felbontas(n, m, k, tagok);
		kiIras(n, k, tagok);
	}
		
	cout << "3. Modszer: ";
	if(kettoHatvany_3(n))
		cout << n << " kettoHatvany!" << endl;	
	else
		cout << n << " NEM kettoHatvany!" << endl;	

	cout << "4. Modszer: ";
	if(kettoHatvany_4(n))
		cout << n << " kettoHatvany!" << endl;	
	else
		cout << n << " NEM kettoHatvany!" << endl;	
	cout << endl;
}
