﻿/*
Legyen x és y két természetes szám. Döntsük el, hogy a két szám hasonló-e. 
a) Két tömb használatával
b) Egy tömb segítségével
c) Tömbhasználat nélkül 
Megjegyzés: Két számot hasonlónak nevezünk, ha számjegyeik halmaza azonos: 2131 és 32211 hasonló 
mivel számjegyeik halmaza ugyanaz: {1,2,3}. 
*/

#include <iostream>
#include <fstream>

using namespace std;

ifstream fin("hasonlok.in");

void elofordul(int x, bool elof[]){
// létrehozzuk az x szám számjegyeinek előfordulástömbjét

	for(int i = 0; i <= 9; i++)
		elof[i] = false;

	while(x > 0){
		elof[x % 10] = true;
		x /= 10;
	}
}

bool azonos_1(int a, int b){

bool elofA[10], elofB[10];
	elofordul(a, elofA);
	elofordul(b, elofB);
	int i = 0; 
	while(i <= 9 && elofA[i] == elofB[i])
		i++;
	return i > 9; 
}

bool ab(int a, int b){
// az a előfordulástömjében vizsgáljuk a b számjegyeinek megfelelő elemeket

bool elofA[10];
	elofordul(a, elofA);
	while(b > 0 && elofA[b % 10])
		b /= 10;
	return b == 0;
}

bool azonos_2(int x, int y){
// x számjegyeit keressük y számjegyei között és fordítva

	return ab(x, y) && ab(y, x);
}

bool AszamjegyeiBben(int a, int b){
// vizsgáljuk, hogy a minden számjegye előfordul-e b-ben
int auxB = b; // másolat b-ről 

	while (a > 0){ 			// vizsgáljuk, hogy a számjegyei megtalálhatók-e b számjegyei között 
		int aUtolsoSzj = a % 10; 
		while (auxB > 0 && aUtolsoSzj != auxB % 10) 
			auxB /= 10; 
		if (auxB == 0)		// ha auxB 0 lett, az a aktuális számjegye nincs meg b-ben 
			return false; 
		auxB = b; 			// visszaállítjuk b értékét 
		a /= 10; 			// levágjuk az a szám utolsó számjegyét 
	} 
	return true; 
} 

bool azonos_3(int x, int y){ 
// vizsgáljuk, hogy x minden számjegye előfordul-e y-ban, és fordítva
	return (AszamjegyeiBben(x, y) && AszamjegyeiBben(y, x));
}

int main(){

int n;
int x, y;
	fin >> n; // tesztek darabszáma
	for(int i = 1; i <= n; i++){
		fin >> x >> y;
		cout << "x = " << x << " y = " << y << " "<< endl;
		cout << "Ket tomb segitsegevel: ";
		if(azonos_1(x, y))
			cout << "Igen" << endl;
		else
			cout << "Nem" << endl;

		cout << "Egy tomb segitsegevel: ";
		if(azonos_2(x, y))
			cout << "Igen" << endl;
		else
			cout << "Nem" << endl;

		cout << "Tombhasznalat nelkul: ";
		if(azonos_3(x, y))
			cout << "Igen" << endl;
		else
			cout << "Nem" << endl;
	}
	return 0;
}