/*
Adott az n (0 < n < 2^31) természetes szám. Határozzuk meg azt a maxPal számot, amely a legnagyobb palindrom, 
amelyet az n szám minden számjegyének átrendezése által kaphatunk. Ha nem lehet kialakítani a palindromot, 
amelyben az n szám minden számjegye szerepeljen, akkor maxPal értéke -1. 
1. Példa: ha n = 215323531, akkor maxPal = 532131235. 
2. Példa: ha n = 12272351, akkor maxPal = -1.
*/

#include <iostream>
#include <string.h>

using namespace std;

int palindrom(int n){
// létrehozzuk az n számjegyeinek gyakoriságtömbjét 

	int gyak[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	while (n > 0){
		gyak[n % 10]++;
		n = n / 10;
	}

	int szam = 0;						// a legnagyobb palindromszám
	int kozep = -1;						// a kozep indexű hely még nincs elfoglalva
	int i = 9;							// a számjegyeket csökkenő sorrendben dolgozzuk fel
	while (i >= 0){
		if (gyak[i] % 2 == 1) {			// az i számjegy páratlan számszor fordul elő
			if (kozep == -1){			// ha a kozep indexű hely még nincs elfoglalva
				kozep = i;				// elhelyezzük az i számjegyet a szám közepére
				gyak[i]--;				// elhasználtunk egy számjegyet az i számjegyek közül
				i = i + 1;
			}
			else
				return -1;				// ha a kozep indexű hely már foglalt, nem tudunk palindromszámot generálni
		}
		else{
			int hany = gyak[i] / 2;		// az i számjegyből hány darabot építünk a számba balról jobbra haladva
			for (int j = 0; j < hany; j++)
				szam = szam * 10 + i;
			gyak[i] = gyak[i] - hany;			// hany darab i számjegyet felhasználtunk
		}
		i--;							// a következő (kisebb) számjegyérték
	}
	
	if(kozep != -1)					// ha a kozep kapott értéket
		szam = szam * 10 + kozep;		// beépítjük a számba
	for(int i = 0; i < 10; i++)		// most növekvő sorrendben dolgozzuk fel a számjegyeket
		for (int j = 0; j < gyak[i]; j++)// minden számjegyet beépítünk annyiszor, ahány maradt mindenikből
			szam = szam * 10 + i;
	return szam;
}

int main(){

	int n;
	cout << "n = "; cin >> n;
	cout << palindrom(n) << endl;
}